/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   fractol_init.c                                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:31:38 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:31:42 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

t_image		*img_init(void *mlx)
{
	t_image	*img;

	img = malloc(sizeof(t_image));
	img->ptr = mlx_new_image(mlx, WIDTH, HEIGHT);
	img->data = mlx_get_data_addr(img->ptr, &img->bpp, &img->l_size, &img->end);
	return (img);
}

t_fractol	*fractol_init(void *mlx, int frac_type)
{
	t_fractol	*fractol;

	if ((fractol = malloc(sizeof(t_fractol))))
	{
		fractol->w_height = HEIGHT;
		fractol->w_width = WIDTH;
		fractol->mlx = mlx;
		fractol->win = mlx_new_window(fractol->mlx, WIDTH, HEIGHT, "FRCTL");
		fractol->img = img_init(fractol->mlx);
		fractol->frac = frac_init(frac_type);
		fractol->fr_funcs[0] = julia;
		fractol->fr_funcs[1] = mandelbrot;
		fractol->fr_funcs[2] = ship;
	}
	return (fractol);
}
