/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   image_routine.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:59:11 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 18:59:12 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

void	new_and_clear_image(t_fractol *fr)
{
	if (fr)
	{
		if (fr->img->ptr)
			mlx_destroy_image(fr->mlx, fr->img->ptr);
		fr->img->ptr = mlx_new_image(fr->mlx, WIDTH, HEIGHT);
		fr->img->data = mlx_get_data_addr(
				fr->img->ptr,
				&fr->img->bpp,
				&fr->img->l_size,
				&fr->img->end);
	}
}

void	put_pixel_to_image(int x, int y, t_color c, t_fractol *fr)
{
	if (x < 0 || y < 0 || x >= fr->w_width || y >= fr->w_height)
		return ;
	*(int *)((fr->img->data + x * fr->img->bpp / 8 + y * fr->img->l_size)) =
			(c.red << 16) | (c.grn << 8) | c.blu;
}
