/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   mandelbrot.c                                       :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:33:30 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:33:56 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

int		complex_man(t_complex new, t_complex com_const, t_frac_data *data)
{
	int			i;
	t_complex	old;

	i = 0;
	while (i < data->max_itr)
	{
		old = new;
		new.rl = old.rl * old.rl - old.im * old.im + com_const.rl;
		new.im = 2 * old.rl * old.im + com_const.im;
		if ((new.rl * new.rl + new.im * new.im) > 4)
			break ;
		i++;
	}
	return (i);
}

t_color	mandelbrot(t_frac_data *ma, int x, int y)
{
	t_complex	new;
	int			i;

	new.rl = 1.5 * (x - WIDTH / 2) / (0.5 * ma->mov.z * WIDTH) +
				ma->mov.x - 0.7;
	new.im = (y - HEIGHT / 2) / (0.5 * ma->mov.z * HEIGHT) +
				ma->mov.y;
	i = complex_man(ma->com_const, new, ma);
	return (gradient((float)i / ma->max_itr, ma->grd));
}
